/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Optimoz Tweaks.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var mtIsFirefox = (document.location.href.indexOf("browser.xul") > 0);
var mtBundle = null;

function mtStartup() {
  // Delay the removal of our handler, so it occurs after this event phase.
  // This avoids a bug that skips other listeners, see
  // http://bugzilla.mozilla.org/show_bug.cgi?id=174320
  setTimeout("window.removeEventListener('load', mtInit, false);",0);
  mtBundle = document.getElementById("moztweaksBundle");
  mtInit();
}

function mtInit() {
  mtInitSidebar();
  mtInitSearchbar();
  mtInitTabs();
}

// Preferences observer object; implements nsIObserver
function mtPrefObserver()
{
  try {
    mtPref.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
        .addObserver(this.domain, this, false);
  } catch(ex) {
    dump("MozTweaks: Failed to observe prefs: " + ex + "\n");
  }
}
mtPrefObserver.prototype =
{
  domain: "moztweaks.",
  observe: function(subject, topic, prefName)
  {
    if (prefName != "moztweaks.freshInstall" && prefName != "moztweaks.sidebar.last") {
      // when MozTweaks pref was changed, we reinitialize
      try{
        mtInit();
      } catch(err){}
    }
  }
}

// Gets a pref setting. If it's missing, set it to a default value.
// For Int prefs, you can optionally specify a minimum and maximum value.
function mtGetPref(name, type, defaultValue, min, max) {
  if (type != "Bool" && type != "Char" && type != "Int") {
    return null;
  }
  var notfound = false;
  var value;
  try {
    value = eval("mtPrefBranch.get" + type + "Pref(\"" + name + "\");");
  } catch (e) {
    notfound = true;
  }
  if (notfound || (type == "Int" && (min || max) && (value > max || value < min))) {
    val = (type == "Char") ? ("\"" + defaultValue + "\"") : defaultValue;
    eval("mtPrefBranch.set" + type + "Pref(\"" + name + "\", " + val + ");");
    return defaultValue;
  } else {
    return value;
  }
}

function mtDummy() {
}

// startup code
window.addEventListener("load", mtStartup, false);
var mtPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
var mtPref = mtPrefService.getBranch(null);
var mtPrefBranch = mtPrefService.getBranch("moztweaks.");
window.moztweaksPrefObserver = new mtPrefObserver();
