/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Optimoz Tweaks.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var prefs = Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefBranch);

function mtInitPrefPanel() {
  if (parent.mtWindow) {
    for (i = 0; i < _elementIDs.length; i++) {
      var curEl = document.getElementById(_elementIDs[i]);
      var prefstring = curEl.getAttribute("prefstring");
      var preftype = curEl.getAttribute("preftype");
      try {
      switch(preftype) {
        case "int": curEl.setAttribute("value", prefs.getIntPref(prefstring)); break;
        case "bool": curEl.checked = prefs.getBoolPref(prefstring); break;
        default: curEl.setAttribute("value", prefs.getCharPref(prefstring)); break;
      }
      } catch(e) {
        alert("error reading " + prefstring + ", type="+preftype+"\n"+e);
      }
      if (curEl.nodeName == "radiogroup") {
        var option;
        for (j = 0; j < curEl.childNodes.length; j++) {
          option = curEl.childNodes[j];
          if (option.getAttribute("value") == curEl.getAttribute("value")) {
            option.setAttribute("selected", "true");
            break;
          }
        }
      }
    }
  } else {
    document.getElementById("searchbarOptions").setAttribute("hidden", "true");
    parent.initPanel("chrome://moztweaks/content/pref/pref-moztweaks.xul");
  }
}

function savePrefs() {
  for (i = 0; i < _elementIDs.length; i++) {
    var curEl = document.getElementById(_elementIDs[i]);
    var prefstring = curEl.getAttribute("prefstring");
    var preftype = curEl.getAttribute("preftype");
    switch(preftype) {
      case "int": prefs.setIntPref(prefstring, curEl.value); break;
      case "bool": prefs.setBoolPref(prefstring, curEl.checked); break;
      default: prefs.setCharPref(prefstring, curEl.getAttribute("value")); break;
    }
  }
}
